<template>
  <img class="text-center" ref="paymentQRCodeElement" />
</template>

<script setup lang="ts">
// Vue Imports.
import { computed, ref, onMounted, onUnmounted } from 'vue'

// Third-party imports.
import { generateQrCode, satsToBCH } from '../lib/utils.js'

// Import Electrum Client.
import { ElectrumClient } from 'electrum-cash'

// Properties
const props = defineProps<{
  invoice: any
}>()

// Emits.
const emit = defineEmits(['paymentReceived'])

// Define constant as BIP21 expects the value in BCH units.
const SATOSHIS_PER_BCH = 100_000_000

// Ensure the invoice contains an address.
if (!props.invoice.outputs[0].address) {
  throw new Error('This invoice does not contain an address.')
}

// Ensure the invoice contains an address.
if (!props.invoice.totals.nativeTotal) {
  throw new Error('This invoice does not contain a valid amount.')
}

// Define an Electrum client (but do not connect yet).
const electrum = new ElectrumClient('ScanToPay.Cash', '1.4.3', 'bch.imaginary.cash', 50004, 'wss')

// Get the address and the amounts from the invoice passed in.
const address = computed(() => props.invoice.outputs[0].address)
const amountSatoshiUnits = computed(() => props.invoice.totals.nativeTotal)
const amountBCHUnits = computed(() => satsToBCH(props.invoice.totals.nativeTotal))

// Set references to our reactive Vue Elements.
const paymentQRCodeUrl = ref<string>('')
const paymentQRCodeElement = ref<HTMLImageElement>()

// Set references to our reactive Vue Elements.
paymentQRCodeUrl.value = `${address.value}?amount=${amountBCHUnits.value}`

async function watchForMatchingPayment () {
  // When we initially subscribe, we will be sent a notification.
  // We want to store the list of UTXOs that already exist here so that we make sure we are only checking for NEW UTXOs by filtering later.
  const processedUnspents = new Set()

  // Wait for the client to connect
  await electrum.connect()

  // Subscribe to the address.
  await electrum.subscribe(async (payload: any) => {
    // Get a list of unspent outputs on the receiving address.
    const unspents = await electrum.request('blockchain.address.listunspent', address.value)

    // If the payload received is not an array, something has gone wrong.
    if (!Array.isArray(unspents)) {
      throw new Error(`Failed to make call to blockchain.address.listunpent on ${address.value}`)
    }

    // Electrum quirk: When we first call subscribe, it will trigger this callback. However, it will NOT return an array.
    // So we don't pick up on the last UTXO before this payment was requested, we check the payload and ignore it if it is not an array.
    if (!Array.isArray(payload)) {
      // Add the initial list of unspents to our list of processed UTXOs.
      unspents.forEach(unspent => processedUnspents.add(unspent.tx_hash))

      // Return to prevent further execution.
      return
    }

    // Filter out unspents that have been processed already by checking our processed unspents list.
    const unprocessedUnspents = unspents.filter(unspent => !processedUnspents.has(unspent.tx_hash))

    // Iterate through each of the unprocessed unspents and check if any match our expected amount.
    for (const unprocessedUnspent of unprocessedUnspents) {
      if (unprocessedUnspent.value === amountSatoshiUnits.value) {
        emit('paymentReceived')
      } else {
        console.log(`Ignoring unspent ${unprocessedUnspent.tx_hash} as it does not match our expected value`)
      }
    }
  }, 'blockchain.address.subscribe', address.value)
}

// When our Vue component is mounted...
onMounted(async (): Promise<void> => {
  // Make sure our paymentQRCodeElement was found.
  if (!paymentQRCodeElement.value) {
    throw new Error('Could not find paymentQRCodeElement')
  }

  // Watch for the payment on the address.
  // NOTE: We do not await this deliberately so that the QR displays quickly.
  //       The user could, theoretically, race it and scan the QR Code quickly. But I do not predict that happening in 99%+ of cases.
  watchForMatchingPayment()

  // Render the Payment QR Code.
  const paymentQRImage = await generateQrCode(paymentQRCodeUrl.value)
  const paymentImageSrc = window.URL.createObjectURL(paymentQRImage)
  paymentQRCodeElement.value.setAttribute('src', paymentImageSrc)
})

// When the Vue component is unmounted...
onUnmounted(async (): Promise<void> => {
  await electrum.disconnect()

  console.log('Electrum disconnected')
})
</script>

<style lang="scss">
  .scissor-container {
    width: 110mm;
    height: 110mm;
    text-align: center;
    border: 1px dashed #000;
    padding: 12mm;
    margin: auto;
  }

  .scissor-container-logo {
    width: 60mm;
    margin-bottom: 1em;
  }

  .scissor-container-qr-code img {
    max-width: 100%;
    max-height: 100%;
  }

  .scissor-container-cta {
    font-weight:bold;
    font-size:2.0em;
  }

  .scissor-container-terminal-id {
    font-size:0.7em;
    color: #666;
  }
</style>
